<?php
define('WP_USE_THEMES', true);
$blog='NULL';
$blogdata='NULL';
$optiondomain = 'system';
$_REQUEST['b']='system';

require('private.php');
require(CONFIGPATH . 'wp-config.php');

get_currentuserinfo();

$site_title = get_settings('site_title');

$wpdb->query("
CREATE TEMPORARY TABLE bloginfo
	SELECT $wpdb->blogs.id, $wpdb->blogs.slug, option_value as blogname, status
	FROM $wpdb->blogs
		INNER JOIN $wpdb->options ON ($wpdb->blogs.id = $wpdb->options.blog)
		INNER JOIN $wpdb->posts
		INNER JOIN $wpdb->post2cat ON (post_id = $wpdb->posts.ID)
		INNER JOIN $wpdb->categories ON (category_id = cat_ID AND $wpdb->categories.blog = $wpdb->options.blog)
	WHERE
		status = 'active' AND
		option_name = 'blogname' AND
		post_title != 'Hello world!' AND
		post_title != 'About'
	ORDER BY post_date_gmt DESC		
");

$blogs = $wpdb->get_results("SELECT DISTINCT(id), slug, blogname, status FROM bloginfo ORDER BY blogname ASC");

$posts = get_recent_posts(10);

if ( isset($_SESSION['slug_error']) ) {
	$slug_error = $_SESSION['slug_error'];
	unset($_SESSION['slug_error']);
}

// ===========================================================================
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head profile="http://gmpg.org/xfn/11">
	<title><?php echo $site_title ?></title>

	<link rel="stylesheet" href="<?php echo LURL ?>/wp-admin/wp-admin.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo LURL ?>/system-admin/lyceum.css" type="text/css" />

	<link rel="alternate" type="application/atom+xml" title="Atom 1.0" href="<?php echo LURL ?>/atom.php" />

	<meta http-equiv="Content-Type" content="text/html; charset=<?php echo get_option('system_charset') ?>" />
</head>


<body>

<div id="PageWrapper" class="Portal">

	<!-- BEGIN: header -->
	<div id="lyceum-header">

		<h1><?php echo $site_title ?></h1>

<?php
	if ($user_identity) {
?>
		<ul id="authentication-tools">
			<li>
				logged in as: <?php printf(__('<strong>%s</strong>'), $user_identity) ?> 
				[<a href="<?php echo LURL ?>/login?action=logout&amp;redirect_to=/portal.php" title="<?php _e('Log out of this account') ?>"><?php _e('Sign Out'); ?></a>]
			</li>
			<li>
<?php
	if ($userdata->user_admin) {
		$system_settings_link = "System Settings";
		if (strpos($_SERVER['REQUEST_URI'],'settings')) { // this is... pretty weak. -jsb
			$system_settings_link = "<strong>" . $system_settings_link . "</strong>";
		} else {
			$system_settings_link = "<a href=\"" . LURL . "/system-admin/settings.php\">" . $system_settings_link . "</a>";
		}
		echo $system_settings_link . " &bull; ";
	}

	$my_account_link = __('My Account');
	if (strpos($_SERVER['REQUEST_URI'],'profile')) { // this is... pretty weak. -jjb
		$my_account_link = "<strong>" . $my_account_link . "</strong>";
	} else {
		$my_account_link = "<a href=\"" . LURL . "/profile\">" . $my_account_link . "</a>";
	}
	echo $my_account_link;
?>
			</li>
		</ul>
<?php
	}
?>

	</div>
	<!-- END: header -->

	<hr />

	<!-- BEGIN: body -->
	<div id="BodyWrapper">

<?php
	if ( isset($slug_error) ) {
?>
		<p class="Error"><?php echo $slug_error; ?></p>
<?php
	}
?>

		<!-- BEGIN: main column -->
		<div id="MainColumn">

			<!-- BEGIN: recent posts -->
			<div id="recent-posts">
				<h2>Recent Posts</h2>
<?php
	if ($posts) {
?>
				<ul>
<?php
		foreach ($posts as $p) {
?>
					<li>
						<strong><a href="<?php echo $p->guid ?>"><?php echo $p->post_title ?></a></strong><br />
						<span>from <a href="<?php echo $p->siteurl ?>"><?php echo $p->blogname ?></a> by <?php echo $p->author_nickname ?></span>
						<div><?php echo strip_tags($p->post_content) ?>... <a href="<?php echo $p->guid ?>">Read More &gt;</a></div>
					</li>
<?php
		}
?>
				</ul>
		
<?php
	} else {
?>
				<p><em>The system does not have any blog posts yet.</em></p>
<?php
	}
?>
			</div>
			<!-- END: recent posts -->


			<!-- BEGIN: all blogs -->
			<div id="all-blogs">
				<h2>All Blogs <span>(<?php echo count($blogs) ?> total)</span></h2>
<?php
	if ($blogs) {
?>
				<ul>
<?php
		if (SUBDOMAINS) {
			foreach ($blogs as $b) {
?>
					<li>
						<a href="http://<?php echo $b->slug . "." . MAINDOMAIN ?>"><?php echo $b->blogname ?></a>
					</li>
<?php
			}
		} else {
			foreach ($blogs as $b) {
?>
					<li>
						<a href="./<?php echo $b->slug ?>"><?php echo $b->blogname ?></a>
					</li>
<?php
			}
		}
?>
				</ul>
<?php
	} else {
?>
				<p><em>
					The system does not have any blogs yet.
<?php
		if ($userdata->user_admin) {
?>
					<a href="system-admin/blog-management.php">Create some now &raquo;</a>
<?php
		}
?>
				</em></p>
<?php
	}
?>
			</div>
			<!-- END: all blogs -->

		</div>
		<!-- END: main column -->

		<hr />

		<!-- BEGIN: side column -->
		<div id="SideColumn">
<?php
	if ($userdata->user_admin) {
?>
			<!-- BEGIN: lyceum admin -->
			<div id="lyceum-admin">
				<h2>Lyceum Admin</h2>
				<ul>
					<li><a href="system-admin/settings.php">System Settings</a></li>
					<li><a href="system-admin/blog-management.php">Manage Blogs</a></li>
					<li><a href="system-admin/user-management.php">Manage Users</a></li>
					<li><a href="system-admin/systemplugins.php">Manage Plugins</a></li>
					<li><a href="system-admin/rewriterules.php">Rewrite Rules</a></li>
				</ul>
			</div>
			<!-- END: lyceum admin -->
<?php
	} elseif ($user_identity) {
?>
			<!-- BEGIN: my blogs -->
			<div id="my-blogs">
				<h2>My Blogs</h2>
<?php
	$myblogs = get_userblogs();

	if ($myblogs) {
?>
				<ul>
<?php
		foreach ($myblogs as $b) {
?>			
					<li>
						<h3><a href="<?php echo $b->home ?>"><?php echo $b->blogname ?></a></h3>
						<p><?php echo $b->tagline ?></p>
						<a href="<?php echo $b->home ?>">view</a> | <a href="<?php echo $b->home ?>/admin">admin</a>
					</li>
<?php
		}
?>
				</ul>
<?php
	} else {
?>
				<p><em>You do not have any blogs yet. <a href="/register">Create one now &raquo;</a></em></p>
<?php
	}
?>
			</div>
			<!-- END: my blogs -->
<?php
	} else {
?>
			<!-- BEGIN: login box -->
			<div id="login-box">

				<h2>Log In</h2>

				<form name="login_form" id="login_form" action="<?php echo WEBROOT ?>/login" method="post">
					<fieldset>
						<div class="Field">
							<label for="username"><?php _e('Username:') ?></label><br />
							<input type="text" name="log" id="username" value="<?php echo attribute_escape(stripslashes($user_login)); ?>" class="TextInput" />
						</div>

						<div class="Field">
							<label for="password"><?php _e('Password:') ?></label><br />
							<input type="password" name="pwd" id="password" value="" class="TextInput" />
						</div>

						<input type="hidden" name="redirect_to" value="/portal.php" />

						<ul class="Inputs">
							<li><input type="checkbox" name="rememberme" id="remember_me" value="forever" class="CheckboxInput" /> <label for="remember_me"><?php _e('Remember me'); ?></label></li>
						</ul>

						<div class="FormAction">
							<input type="submit" value="Log In" />
						</div>
			
					</fieldset>
				</form>

				<div id="new-user">
					<h3>New User?</h3>
					<p><a href="register">Register now</a> for an account.</p>
				</div>

			</div>
			<!-- END: login box -->
<?php
	}
?>
		</div>
		<!-- END: side column -->

	</div>
	<!-- END: body -->

	<div class="ClearFix"><!-- NOTE: do not remove --></div>

	<hr />

	<!-- BEGIN: footer -->
	<div id="lyceum-footer">
		<p>Powered by <a href="http://lyceum.ibiblio.org/">Lyceum</a></p>
	</div>
	<!-- END: footer -->
	
</div>


</body>

</html>
